
! Funcin de la librera InformatE 6/7E 000630 modificada por Presi

!----------------------------------------------------------------------------
! AQUI VIENE EL VERDADERO PARSER
! ----------------------------------------------------------------------------
!  Para simplificar un poco la descripcin, he aqui un mapa grosero de
!  la rutina principal:
!
!  (A)    Obtener la entrada, manejar "eepa" y "repetir"
!  (B)    Es una direccin, y por tanto un Ir implcito?, si es as
!         saltar a (K)
!  (C)    Estamos interpelando a alguien?
!  (D)    Obtener el verbo. Intentar todas las lneas de sintaxis para
!         ese verbo
!  (E)    Descomponer una lnea de sintaxis en tokens analizados
!  (F)    Adelantarse para los avisos adelantados de multiexcepto/multidentro
!  (G)    Interpretar cada token de uno en uno (la llamada a
!         InterpretarToken hace casi todo el trabajo)
!  (H)    Interpreta de forma mnima la conversacin no reconocida y retorna
!  (I)    Imprimir el mejor mensaje de error posible
!  (J)    Reintentar todo desde el principio
!  (K)    Finalmente, comprobar si hay "y luego" y ms instrucciones,
!         retornar.
!
!  Estos puntos estratgicos (del A al K) estn maracados en los comentarios.
!
!  Observar que hay tres lugares diferentes donde puede ocurrir un retorno.
! ----------------------------------------------------------------------------

[ Parser__parse  resultados   sintaxis linea num_lineas direccion_linea i j k
                           token l m;

!  **** (A) ****

!   Primero, si estamos en modo "no poseido", an tenemos un comando
!   sin terminar desde la ltima vez (por ejemplo, el jugador ha
!   escrito "comer bollo", que se ha interpretado como un "coger
!   bollo" la ltima vez, y un "comer bollo" retardado hasta
!   ahora). As que en este caso retornamos el comando guardado.

    if (modo_noposeido==1)
    {   for (i=0:i<8:i++) resultados-->i=resultados_guardados-->i;
        modo_noposeido=0; rtrue;
    }

    if (modo_mantenido==1)
    {   modo_mantenido=0;
        Tokenise__(buffer,parse);
        jump ReInterpreta;
    }

  .ReTeclea;

    Teclado(buffer,parse);
    #IfDef TIEMPO_REAL; if (no_interpretar) return; #EndIf;

  .ReInterpreta;

    parser_inflexion = name;

!   Suponer inicialmente que el comando va dirigido al "jugador", y
!   que la primera palabra es el verbo

    num_palabras=parse->1;
    np=1;

! Traduccin preliminar, para separar las partculasa pronominales del
! verbo, quitar los acentos, etc
#ifdef IdiomaAInformes;
    IdiomaAInformes();
#ifv5;
!   Re-tokenise:
    Tokenise__(buffer,parse);
#endif;
#endif;

! Damos la oportunidad al programador de que haga transformaciones
! adicionales en los buffers, antes de pasar a interpretarlos
    AntesDelParsing();
    num_palabras=parse->1;

    k=0;
#ifdef DEBUG;
! Para depuracin, se escribe cada palabra del buffer entre comillas,
! seguida de la palabra de diccionario con que encaja (o una
! interrogacin si no encaja con ninguna). Cada palabra se separa de
! la siguiente por una "/"
    if (parser_trace>=2)
    {   print "[ ";
        for (i=0:i<num_palabras:i++)
        {   j=parse-->(i*2 + 1);
            k=DireccionDePalabra(i+1);
            l=LongitudDePalabra(i+1);
            print "~"; for (m=0:m<l:m++) print (char) k->m; print "~ ";

            if (j == 0) print "?";
            else
            {   if (CompararSinSigno(j, 0-->4)>=0
                    && CompararSinSigno(j, 0-->2)<0) print (address) j;
                else print j;
            }
            if (i ~= num_palabras-1) print " / ";
        }
        print " ]^";
    }
#endif;
    palabra_verbonum=1;
    actor=jugador;
    localizacion_actor = TopeAlcanzable(jugador);
    gramatica_normal_tras = 0;

  .CasiReInterpreta;

    token_alcance = 0;
    accion_que_seria = NULL;

!  Empezar desde donde suponemos que est el verbo

  .PrincipioComando;
    np=palabra_verbonum;
    palabra_verbo = SiguientePalabraParar();

!  Si aqu no hay texto, debemos tener algo como "persona,"

    if (palabra_verbo==-1)
    {   mejor_tipoerror = ATASCADO_PE; jump DarError; }

!   Ahora intentaremos "repetir" o "re", que son casos especiales:
!   No permitir "repetir" si no se haba escrito nada antes; de otra
!   forma simplemente copiar el texto previo

    if (palabra_verbo==OTRAVEZ2__WD or OTRAVEZ3__WD) palabra_verbo=OTRAVEZ1__WD;
    if (palabra_verbo==OTRAVEZ1__WD)
    {   if (actor~=jugador)
        {   M__L(##Miscelanea,20); jump ReTeclea; }
        if (buffer3->1==0)
        {   M__L(##Miscelanea,21); jump ReTeclea; }
        for (i=0:i<120:i++) buffer->i=buffer3->i;
        jump ReInterpreta;
    }

!  Salvar la entrada actual, por si la prxima vez se pide "repetir"

    if (palabra_verbo~=OTRAVEZ1__WD)
        for (i=0:i<120:i++) buffer3->i=buffer->i;

! Damos oportunidad al objeto "jugador" a que interprete por si mismo
! la lnea.
    if (gramatica_normal_tras==0)
    {   i = EjecutarRutinas(actor, gramatica);
        #ifdef DEBUG;
        if (parser_trace>=2 && actor.gramatica~=0 or NULL)
            print " [La propiedad ~gramatica~ ha retornado ", i, "]^";
        #endif;
        if (i<0) { gramatica_normal_tras = palabra_verbonum; i=-i; }
        if (i==1)
        {   resultados-->0 = accion;
            resultados-->1 = uno;
            resultados-->2 = otro;
            rtrue;
        }
        if (i~=0) { palabra_verbo = i; np--; palabra_verbonum--; }
        else
        {   np = palabra_verbonum; palabra_verbo=SiguientePalabra();
        }
    }
    else gramatica_normal_tras=0;

!  **** (B) ****

!  Damos oportunidad al programador a que defina su propia regla para
!  decidir cuando una palabra es verbo y cuando no. En particular
!  puede servir para verbos que ocupen varias palabras, o para admitir
!  tambin como verbo la forma infinitiva del mismo

    #ifdef IdiomaEsVerbo;
    if (palabra_verbo==0)
    {   i = np; palabra_verbo=IdiomaEsVerbo(buffer, parse, palabra_verbonum);
        np = i;
    }
    #endif;

!  Si la primera palabra no se ha reconocido como verbo, puede ser una
!  direccin o el nombre de alguien con quien hablar

    if (palabra_verbo==0 || ((palabra_verbo->#dict_par1) & 1) == 0)
    {   

!  Entonces, es la primera palabra un objeto contenido en el objeto
!  especial "brujula"? Esto necesita usar DominioNombre, una rutina
!  que intenta encajar un nombre con un objeto, retornando el
!  nmero del objeto o 0 si no ha habido ninguno vlido, o
!  CODIGO_REPARSE si ha reestructuraado la tabla de parsing de
!  modo que hay que recomenzar la interpretacin de nuevo

        np=palabra_verbonum; modo_indef = false; filtro_token = 0;
        l=DominioNombre(brujula,0,0);
        #IfDef TIEMPO_REAL; if (no_interpretar) return; #EndIf;
	if (l==CODIGO_REPARSE) jump ReInterpreta;

!  Si es una direccin, ya tenemos el resultado de la interpretacin
!  accion=IrSub, num argumentos=1, argumento 1=la direccin.

        if (l~=0)
        {   resultados-->0 = ##Ir;
            resultados-->1 = 1;
            resultados-->2 = l;
            jump BuscarMas;
        }

!  **** (C) ****

!  Comprobemos que hay una coma (comando tipo "alguien, haz algo") si
!  no estamos ya en una. Esta simplificacin nos evita
!  preocupaciones como "robot, mago, eres idiota", que le dice
!  al robot que le diga al mago que es un idiota.

        if (actor==jugador)
        {   for (j=2:j<=num_palabras:j++)
            {   i=SiguientePalabra(); if (i==palabra_coma) jump Conversacion;
            }
            palabra_verbo=VerboDesconocido(palabra_verbo);
            if (palabra_verbo~=0) jump VerboAceptado;
        }

        mejor_tipoerror=VERBO_PE; jump DarError;

!  SiguientePalabra avanz el nmero de palabra np en uno cada vez,
!  as que ahora hemos pasado la coma (una coma es una palabra
!  por derecho propio en la tabla)

      .Conversacion;
        j=np-1;
        if (j==1) { M__L(##Miscelanea,22); jump ReTeclea; }

!  Usar DominioNombre (en el contexto de "criatura animada") para ver
!  si las palabras pueden ser el nombre de alguien cercano

        np=1; elsiguiente=TOKEN_POSEIDO;
        razon_alcance = RAZON_HABLAR;
        l=DominioNombre(jugador,localizacion_actor,6);
        #IfDef TIEMPO_REAL; if (no_interpretar) return; #EndIf;
        razon_alcance = RAZON_PARSING;
        if (l==CODIGO_REPARSE) jump ReInterpreta;

        if (l==0) { M__L(##Miscelanea,23); jump ReTeclea; }

!  El objeto al que nos dirigimos debe como mnimo ser "hablable" si
!  no es "animado" (esta distincin nos permite, por ejemplo,
!  hablar a un micrfono sin que el parser piense que el
!  micrfono es humano)

        if (l hasnt animado && l hasnt hablable)
        {   M__L(##Miscelanea, 24, l); jump ReTeclea; }

!  Comprobar que no haya palabras misteriosas entre el final del
!  nombre de la persona y la coma, (por ejemplo, "enano
!  dsdfsdf, ve al norte"

        if (np~=j)
        {   M__L(##Miscelanea, 25); jump ReTeclea; }

!  El jugador ha nombrado a alguien correctamente. Ajustar "-le"
!  "l" y "ella"

        ActualizarPronombre(l);

!  Ponmer la variable global "actor", ajustar el nmero de la primera
!  palabra e interpretar de nuevo desde ella

        palabra_verbonum=j+1; actor=l;
        localizacion_actor=TopeAlcanzable(l);
        #ifdef DEBUG;
        if (parser_trace>=1)
            print "[El actor es ", (el) actor, " y se halla en ",
                (name) localizacion_actor, "]^";
        #endif;
        jump PrincipioComando;
    }

!  **** (D) ****

   .VerboAceptado;

!  Definitivamente, tenemos un verbo, no una direccin, tanto si hemos
!  llegado aqu va "coger..." o va "persona, coge..." Obtengamos la
!  bandera "meta" para este verbo.

    meta=((palabra_verbo->#dict_par1) & 2)/2;

!  No puedes ordenar a otros "putunacion" o cosas as...

    if (meta==1 && actor~=jugador)
    {   mejor_tipoerror=VERBO_PE; meta=0; jump DarError; }

!   Ahora asignamos a "i" el correspondiente nmero de verbo,
!   almacenado en la entrada de diccionario (en una curiosa forma
!   255-n, debido a razones histricas de Infocom)...

    i=$ff-(palabra_verbo->#dict_par2);

!  ...y buscamos la i-sima entrada en la tabla de verbos, cuya
!  direccin est en la palabra 7 de la mquina Z (en la cabecera), de
!  modo que podamos llegar a la direccin de la tabla de sintaxis para
!  ese verbo...

    sintaxis=(0-->7)-->i;

!  ...y ahora podamos ver cuantas lneas (esto es, patrones diferentes
!  que corresponden al mismo verbo) estn almacenados en la tabla de
!  interpretacin... 

    num_lineas=(sintaxis->0)-1;

!  ...y ahora vamos a travs de todas ellas de una en una.
!  Para evitar que  palabra_pronombre se malinterprete...

   palabra_pronombre=NULL; objeto_pronombre=NULL;

   #ifdef DEBUG;
   if (parser_trace>=1)
   {    print "[Interpretando el verbo '", (address) palabra_verbo,
              "' (", num_lineas+1, " lneas)]^";
   }
   #endif;

   mejor_tipoerror=ATASCADO_PE; proxmejor_tipoerror=ATASCADO_PE;

!  "mejor_tipoerror" es el error actual para el
!  fracaso-al-encajar. Pro defecto es el menos informativo "no
!  entiendo esa frase". proxmejor_tipoerror recuerda la mejor
!  alternativa que tenemos antes de preguntar a un token de alcance
!  por un mensaje de error (esto es, el mejor error sin contar
!  PREGUNTAAMBITO_PE).


!  **** (E) ****

    direccion_linea = sintaxis + 1;

    for (linea=0:linea<=num_lineas:linea++)
    {   
        for (i = 0 : i < 32 : i++)
        {   linea_token-->i = TOKEN_FINAL;
            linea_tipot-->i = TT_ELEMENTAL;
            linea_tdatos-->i = TOKEN_FINAL;
        }

!  Desempaquetamos la lnea de sintaxis del formato Inform en tres
!  arrays; nos aseguramos de que la secuencia de tokens
!  termine en un TOKEN_FINAL

        direccion_linea = DesempaquetarLineaGramatica(direccion_linea);
            
        #ifdef DEBUG;
        if (parser_trace >= 1)
        {   if (parser_trace >= 2) new_line;
            print "[lnea ", linea; DepurarLineaGramatica();
            print "]^";
        }
        #endif;

!  No estamos en modo "no poseido" u otros modos deductivos, y no
!  hemos introducido ningn parmetro an ni nmeros
!  especiales. La lista de mltiples objetos est an vaca.

        no_poseido=0;
        deducedesde=0;
        parametros=0;
        nsns=0; palabra_especial=0; numero_especial=0;
        objeto_multiple-->0 = 0;
        multi_contexto = 0;
        tipoerror=ATASCADO_PE;

!  Poner el marcador de palabra justo detrs del verbo

        np=palabra_verbonum+1;

!  **** (F) ****
!  Hay dos casos especiales en los que interpretar un token ahora
!  tiene que tener en cuenta el resultado de interpretar otro
!  despus, y estos dos casos (multiexcepto y multidentro) se
!  ven ayudados por un rpido vistazo adelante, para averiguar
!  el token futuro ahora. Slo podremos hacer esto en el
!  caso ms simple (pero el ms comn):
!
!     multiexcept <preposiciones> nombre
!
!  y anlogamente para multidentro

        aviso_adelantado = NULL; modo_indef = false;
        for (i=0,m=false,contadorp=0:
	     linea_token-->contadorp ~= TOKEN_FINAL:contadorp++)
        {   token_alcance = 0;
	    
            if (linea_tipot-->contadorp ~= TT_PREPOSICION) i++;
	    
            if (linea_tipot-->contadorp == TT_ELEMENTAL)
            {   if (linea_tdatos-->contadorp == TOKEN_MULTI) m=true;
                if (linea_tdatos-->contadorp
                    == TOKEN_MULTIEXCEPTO or TOKEN_MULTIDENTRO  && i==1)
                {   !   La primera no-preposicin es "multiexcepto" o
		    !   "multidentro", as que hay que mirar adelante
		    
                    #ifdef DEBUG;
                    if (parser_trace>=2) print " [Intentando mirar adelante]^";
                    #endif;
		    
                    !   Necesitamos que vaya seguido por una o ms preposiciones.
		    
                    contadorp++;
                    if (linea_tipot-->contadorp == TT_PREPOSICION)
                    {   while (linea_tipot-->contadorp == TT_PREPOSICION)
			contadorp++;
			
                        if ((linea_tipot-->contadorp == TT_ELEMENTAL)
                            && (linea_tdatos-->contadorp == TOKEN_NOMBRE))
                        {
                            !  Avanzamos tras la primera preposicin
			    
                            while (np <= num_palabras)
                            {   if (SiguientePalabra()
				    == linea_tdatos-->(contadorp-1))
			    {   l = DominioNombre(localizacion_actor, actor,
                                            	  TOKEN_NOMBRE);
                                #IfDef TIEMPO_REAL;
                                  if (no_interpretar) return;
                                #EndIf;
				#ifdef DEBUG;
				if (parser_trace>=2)
				{   print " [Avanzamdo hasta el
					token ~nombre~: ";
				    if (l==CODIGO_REPARSE)
					print "peticin de re-interpretacin]^";
				    if (l==1) print "pero se ha
					encontrado multiple]^";
				    if (l==0) print "error ", tipoerror, "]^";
				    if (l>=2) print (el) l, "]^";
				}
				#endif;
				if (l==CODIGO_REPARSE) jump ReInterpreta;
				if (l>=2) aviso_adelantado = l;
			    }
                            }
                        }
                    }
                    break;
                }
            }
        }

!   A "coger multi" se le aplican reglas de interpretacin ligeramente
!   diferentes, para evitar que "coger todo" se comporte de
!   forma que llame a engao (aunque correcta) cuando no hay
!   nada que coger.

        regla_coger_todo = 0;
        if (m && parametros_deseados==1 && accion_que_seria==##Coger)
            regla_coger_todo = 1;

! Y ahora empezamos propiamente. Como precaucin, borramos todas las
! variables de nuevo (pueden haber sido modificadas por la
! llamada a DominioNombre, que pudo haber llamado a cdigo
! externo que pudo haber hecho cualquier cosa!

        no_poseido=0;
        deducedesde=0;
        parametros=0;
        nsns=0; palabra_especial=0; numero_especial=0;
        objeto_multiple-->0 = 0;
        tipoerror=ATASCADO_PE;
        np=palabra_verbonum+1;

!  **** (G) ****
!  "patron" va acumulando gradualmente lo que se ha reconocido de
!  momento, de modo que pueda ser reimpreso por el parser ms adelante

        for (contadorp=1::contadorp++)
        {   patron-->contadorp = PATRON_NULO; token_alcance=0;

            token = linea_token-->(contadorp-1);
            elsiguiente = linea_token-->contadorp;

            #ifdef DEBUG;
            if (parser_trace >= 2)
               print " [lnea ", linea, " token ", contadorp,
		   " palabra ", np, " : ", (DepurarToken) token, "]^";
            #endif;

            if (token ~= TOKEN_FINAL)
            {   razon_alcance = RAZON_PARSING;
                l = InterpretarToken(resultados, contadorp-1);
                #IfDef TIEMPO_REAL;
                  if (no_interpretar) return;
                #EndIf;
                razon_alcance = RAZON_PARSING;

                #ifdef DEBUG;
                if (parser_trace >= 3)
                {   print "  [el token ha ";
                    if (l==CODIGO_REPARSE)
			print "causado peticin de reinterpretar]^";
                    if (l==0)
			print "causado un fallo con error ", tipoerror, "]^";
                    if (l==1)
			print "sido interpretado con xito]^";
                }
                #endif;

                if (l==CODIGO_REPARSE) jump ReInterpreta;
                if (l==0)    break;
            }
            else
            {

! Si el jugador ha introducido suficiente texto, pero an hay ms
! texto: almacenar el patrn de momento, para ser capaz de producir un
! mensaje de error decente si resulta ser lo mejor que podemos
! conseguir, y entretanto dejamos de lado esta lnea

! Sin embargo, si el texto superfulo comienza con una coma o
! "ydespues" entonces estamos al comienzo de otra instruccin

                if (np <= num_palabras)
                {   l=SiguientePalabra();
                    if (l==DESPUES1__WD or DESPUES2__WD or DESPUES3__WD or palabra_coma)
                    {   modo_mantenido=1; mant_np=np-1; }
                    else
                    {   for (m=0:m<32:m++) patron2-->m=patron-->m;
                        contadorp2=contadorp;
                        tipoerror=HASTAQUI_PE; break;
                    }
                }

! Ahora necesitamos revisar el objeto mltiple, debido al nico objeto
! que conocemos ahora (pero no lo hacemos cuando la lista ha sido
! construida)

                if (parametros>=1 && resultados-->2 == 0)
                {   l=RevisarMulti(resultados-->3);
                    if (l~=0) { tipoerror=l; break; }
                }
                if (parametros>=2 && resultados-->3 == 0)
                {   l=RevisarMulti(resultados-->2);
                    if (l~=0) { tipoerror=l; break; }
                }

! Para evitar que el caso de "coger todo" deduzca que quiere coger al
! propio jugador cuando no hay nada ms en la vecindad

                if (regla_coger_todo==2 && resultados-->2 == actor)
                {   mejor_tipoerror = NADA_PE; jump DarError;
                }

                #ifdef DEBUG;
                if (parser_trace>=1)
                    print "[Lnea interpretada con xito]^";
                #endif;

!  La lnea ha encajado correctamente con el texto. Declarar que la
!  entrada no tiene errores

                eepa_desde = 0;



!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

! parte modificada por Presi para evitar el mensajito entre corchetes



!  ...explicar las deducciones hechas (usando el patrn)

!                if (deducedesde~=0)
!                {   print "["; ImprimirComando(deducedesde); print "]^";
!                }


! fin de la parte modificada

!ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ


!  ...copiar el nmero de accin y el nmero de parmetros...

                resultados-->0 = accion_que_seria;
                resultados-->1 = parametros;

!  ...dar la vuelta a los parmetros "uno" y "otro", si es necesario...

                if (accion_invertida && parametros==2)
                {   i = resultados-->2; resultados-->2 = resultados-->3;
                    resultados-->3 = i;
                    if (nsns == 2)
                    {   i = numero_especial1; numero_especial1=numero_especial2;
                        numero_especial2=i;
                    }
                }

!  ...y resetear los objetos tipo "-lo" al primero de los parmetros,
!  si es que hay uno (y realmente es un objeto)
		
                if (parametros > 0 && resultados-->2 >= 2)
		    if (objeto_pronombre == NULL) ! Patch 18/4/1999
                    	ActualizarPronombre(resultados-->2);

!  ...y ocuparse del caso en el que un objeto se ha permitido usar
!  como parmetro, incluso aunque el jugador no lo tena y debera
!  tenerlo: en este caso, mantener los resultados hasta la siguiente
!  llamada, pasar al modo "no poseido", contarle al jugador lo que
!  est pasando y retornar una peticin de "coger" en su lugar (coger
!  implcito)...

                if (no_poseido~=0 && actor==jugador)
                {   modo_noposeido=1;
                    for (i=0:i<8:i++) resultados_guardados-->i = resultados-->i;
                    resultados-->0 = ##Coger;
                    resultados-->1 = 1;
                    resultados-->2 = no_poseido;
                    M__L(##Miscelanea, 26, no_poseido);
                }

!  (Observar que los "coger implcitos" slo se generan para el
!  jugador y no para otros actores. Esto evita que se imprima texto
!  que, aunque enteramente lgico, podra ser confuso.)

!  ...y retornar del parser, tras haber encajado con xito una lnea

                if (modo_mantenido==1) { np=mant_np; jump BuscarMas; }
                rtrue;
            }
        }

!  La lnea no ha encajado.  Seguimos en el bucle for externo, para
!  probar la siguiente lnea de la gramtica.

        if (tipoerror>mejor_tipoerror) mejor_tipoerror=tipoerror;
        if (tipoerror~=PREGUNTAAMBITO_PE && tipoerror>proxmejor_tipoerror)
	    proxmejor_tipoerror=tipoerror;

!  ...a menos que la lnea fuera algo como "coger todo", y faallara
!  debido a que nada encjara en "todo", en cuyo caso paramos y
!  damos un error ya

        if (regla_coger_todo == 2 && tipoerror==NADA_PE) break;
   }

!   Hemos revisado toda la gramtica, y han fallado todas las lneas.

!  **** (H) ****

  .DarError;
        tipoerror=mejor_tipoerror;

!  Los errores se manejan de forma diferente, segn a quen
!  estuvieramos hablandole.

!  Si el comando se diriga a alguien (no al jugador, como en "enano,
!  sdfg"), entonces se toma como una conversacin en la que el parser
!  no debe entrar.

    if (actor~=jugador)
    {   if (gramatica_normal_tras>0)
        {   palabra_verbonum = gramatica_normal_tras;
            jump CasiReInterpreta;
        }
        np=palabra_verbonum;
        palabra_especial=SiguientePalabra();
        if (palabra_especial==palabra_coma)
        {   palabra_especial=SiguientePalabra();
            palabra_verbonum++;
        }
        numero_especial=IntentarNumero(palabra_verbonum);
        resultados-->0=##NoComprendido;
        resultados-->1=2;
        resultados-->2=1; numero_especial1=palabra_especial;
        resultados-->3=actor;
        consultar_desde = palabra_verbonum;
	consultar_num_palabras = num_palabras-consultar_desde+1;
        rtrue;
    }

!  **** (I) ****

!   Si el actor era el jugador (ej, "coge sdfg"), el error debe
!   imprimirse, y volver a pedir un comando nuevo. Hay tres casos
!   en los que hay que manejar la palabra eepa

    if (ErrorParser(tipoerror)~=0) jump ReTeclea;
    palabra_pronombre = palabra__pronombre; objeto_pronombre = objeto__pronombre;

    if (tipoerror==ATASCADO_PE)   { M__L(##Miscelanea, 27); eepa_desde=1; }
    if (tipoerror==HASTAQUI_PE)    { M__L(##Miscelanea, 28);
                             for (m=0:m<32:m++) patron-->m = patron2-->m;
                             contadorp=contadorp2; ImprimirComando(0); print ".^";
                           }
    if (tipoerror==NUMERO_PE)  M__L(##Miscelanea, 29);
    if (tipoerror==NOVEO_PE) { M__L(##Miscelanea, 30); eepa_desde=eepa_guardado; }
    if (tipoerror==MUYPOCO_PE)  M__L(##Miscelanea, 31);
    if (tipoerror==NOTIENES_PE) { M__L(##Miscelanea, 32); eepa_desde=eepa_guardado; }
    if (tipoerror==MULTI_PE)   M__L(##Miscelanea, 33);
    if (tipoerror==MMULTI_PE)  M__L(##Miscelanea, 34);
    if (tipoerror==PRONOM_PE)   M__L(##Miscelanea, 35);
    if (tipoerror==EXCEPTO_PE)  M__L(##Miscelanea, 36);
    if (tipoerror==ANIMA_PE)   M__L(##Miscelanea, 37);
    if (tipoerror==VERBO_PE)    M__L(##Miscelanea, 38);
    if (tipoerror==ESCENARIO_PE) M__L(##Miscelanea, 39);
    if (tipoerror==YANOPRON_PE)
    {   if (objeto_pronombre == NULL) M__L(##Miscelanea, 35);
                            else M__L(##Miscelanea, 40);
    }
    if (tipoerror==KKFINAL_PE) M__L(##Miscelanea, 41);
    if (tipoerror==HAYPOCOS_PE)  M__L(##Miscelanea, 42, multi_hallado);
    if (tipoerror==NADA_PE) { if (multi_esperado==100) M__L(##Miscelanea, 43);
                             else M__L(##Miscelanea, 44);  }

    if (tipoerror==PREGUNTAAMBITO_PE)
    {   estadio_alcance=3;
        if (indirect(error_alcance)==-1)
        {   mejor_tipoerror=proxmejor_tipoerror; jump DarError;  }
    }

!  **** (J) ****

!   Y volvemos, prcticamente, hasta el primer punto

    jump ReTeclea;

!  ...teniendo cuidado de no volver totalmente al principio, para
!  evitar un bucle infinito de un comando "retardado" que est
!  causando un error


!  **** (K) ****

!  En este punto, el valor de retorno ya est listo, Simplemente
!  comprobamos si hay un "ydespues" seguido de ms comandos.
    
   .BuscarMas;

   if (np>num_palabras) rtrue;

   i=SiguientePalabra();
   if (i==DESPUES1__WD or DESPUES2__WD or DESPUES3__WD or palabra_coma)
   {   if (np>num_palabras)
       {   modo_mantenido = false; return; }
       i = DireccionDePalabra(palabra_verbonum);
       j = DireccionDePalabra(np);
       for (:i<j:i++) i->0 = ' ';
       i = SiguientePalabra();
       if (i==OTRAVEZ1__WD or OTRAVEZ2__WD or OTRAVEZ3__WD)
       {   ! Borrar las palabras "ydespues repite" del buffer de
	   ! repeticin, para evirar un bucle infinito que hemos
	   ! detectado que puede ocurrir

           i = DireccionDePalabra(np-2)-buffer;
           if (np > num_palabras) j = 119; else j = DireccionDePalabra(np)-buffer;
           for (:i<j:i++) buffer3->i = ' ';
       }
       Tokenise__(buffer,parse); modo_mantenido = true; return;
   }
   mejor_tipoerror=HASTAQUI_PE; jump DarError;
];
